
require "./AI/Const.lua"
require "./AI/Util.lua"
require "./AI/Alchemist.lua"
require "./AI/Homunculus.lua"
require "./AI/Global.lua"

-----------------------------
-- state
-----------------------------
IDLE_ST					= 0
FOLLOW_ST					= 1
CHASE_ST					= 2
ATTACK_ST					= 3
MOVE_CMD_ST					= 4
STOP_CMD_ST					= 5
ATTACK_OBJECT_CMD_ST			= 6
ATTACK_AREA_CMD_ST			= 7
PATROL_CMD_ST				= 8
HOLD_CMD_ST					= 9
SKILL_OBJECT_CMD_ST			= 10
SKILL_AREA_CMD_ST				= 11
FOLLOW_CMD_ST				= 12
----------------------------



------------------------------------------
-- global variable
------------------------------------------
MyState				= IDLE_ST	-- ŏ̏Ԃ͋x
MyEnemy				= 0		-- G id
MyDestX				= 0		-- ړIn xW
MyDestY				= 0		-- ړIn yW
MyPatrolX				= 0		-- @ړIn xW
MyPatrolY				= 0		-- @ړIn yW
ResCmdList				= List.new()	-- \R}hXg
MySkill					= 0		-- zNX̃XL
MySkillLevel				= 0		-- zNX̃XLx
------------------------------------------


function AI(homId)

	InitGlobal(homId)

	local msg	= GetMsg (homId)			-- command
	local rmsg	= GetResMsg (homId)		-- reserved command
	
	if msg[1] == NONE_CMD then
		if rmsg[1] ~= NONE_CMD then
			if List.size(ResCmdList) < 10 then
				List.pushright (ResCmdList,rmsg) -- \R}hۑ
			end
		end
	else
		List.clear (ResCmdList)	-- VR}h͂ꂽA\R}h͍폜
		ProcessCommand (msg)	-- R}h 
	end

		
	-- ԏ 
 	if (MyState == IDLE_ST) then
		OnIDLE_ST ()
	elseif (MyState == CHASE_ST) then					
		OnCHASE_ST ()
	elseif (MyState == ATTACK_ST) then
		OnATTACK_ST ()
	elseif (MyState == FOLLOW_ST) then
		OnFOLLOW_ST ()
	elseif (MyState == MOVE_CMD_ST) then
		OnMOVE_CMD_ST ()
	elseif (MyState == STOP_CMD_ST) then
		OnSTOP_CMD_ST ()
	elseif (MyState == ATTACK_OBJECT_CMD_ST) then
		OnATTACK_OBJECT_CMD_ST ()
	elseif (MyState == ATTACK_AREA_CMD_ST) then
		OnATTACK_AREA_CMD_ST ()
	elseif (MyState == PATROL_CMD_ST) then
		OnPATROL_CMD_ST ()
	elseif (MyState == HOLD_CMD_ST) then
		OnHOLD_CMD_ST ()
	elseif (MyState == SKILL_OBJECT_CMD_ST) then
		OnSKILL_OBJECT_CMD_ST ()
	elseif (MyState == SKILL_AREA_CMD_ST) then
		OnSKILL_AREA_CMD_ST ()
	elseif (MyState == FOLLOW_CMD_ST) then
		OnFOLLOW_CMD_ST ()
	end


end


------------- command process  ---------------------
function	OnMOVE_CMD (x,y)
	
	TraceAI ("OnMOVE_CMD")

	if ( x == MyDestX and y == MyDestY and MOTION_MOVE == homunculus:getMotion()) then
		return		-- ړInƌݒn̏ꍇ́AȂ
	end

	local curX, curY = GetV (V_POSITION,homunculus:getId())
	if (math.abs(x-curX)+math.abs(y-curY) > 15) then		-- ړIn苗ȏȂ (T[o[ŉ͏Ȃ)
		List.pushleft (ResCmdList,{MOVE_CMD,x,y})			-- ̖ړInւ̈ړ\񂷂
		x = math.floor((x+curX)/2)							-- Ԓn_ֈړ
		y = math.floor((y+curY)/2)							-- 
	end

	Move (homunculus:getId(),x,y)	
	
	MyState = MOVE_CMD_ST
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MySkill = 0

end


function	OnSTOP_CMD ()

	TraceAI ("OnSTOP_CMD")

	if (homunculus:getMotion() ~= MOTION_STAND) then
		Move (homunculus:getId(),GetV(V_POSITION,homunculus:getId()))
	end
	MyState = IDLE_ST
	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MySkill = 0

end


function	OnATTACK_OBJECT_CMD (id)

	TraceAI ("OnATTACK_OBJECT_CMD")

	MySkill = 0
	MyEnemy = id
	MyState = CHASE_ST

end


function	OnATTACK_AREA_CMD (x,y)

	TraceAI ("OnATTACK_AREA_CMD")

	if (x ~= MyDestX or y ~= MyDestY or MOTION_MOVE ~= homunculus:getMotion()) then
		Move (homunculus:getId(),x,y)	
	end
	MyDestX = x
	MyDestY = y
	MyEnemy = 0
	MyState = ATTACK_AREA_CMD_ST
	
end


function	OnPATROL_CMD (x,y)

	TraceAI ("OnPATROL_CMD")

	MyPatrolX , MyPatrolY = GetV (V_POSITION,homunculus:getId())
	MyDestX = x
	MyDestY = y
	Move (homunculus:getId(),x,y)
	MyState = PATROL_CMD_ST

end


function	OnHOLD_CMD ()

	TraceAI ("OnHOLD_CMD")

	MyDestX = 0
	MyDestY = 0
	MyEnemy = 0
	MyState = HOLD_CMD_ST

end


function	OnSKILL_OBJECT_CMD (level,skill,id)

	TraceAI ("OnSKILL_OBJECT_CMD")

	MySkillLevel = level
	MySkill = skill
	MyEnemy = id
	MyState = CHASE_ST

end


function	OnSKILL_AREA_CMD (level,skill,x,y)

	TraceAI ("OnSKILL_AREA_CMD")

	Move (homunculus:getId(),x,y)
	MyDestX = x
	MyDestY = y
	MySkillLevel = level
	MySkill = skill
	MyState = SKILL_AREA_CMD_ST
	
end


function	OnFOLLOW_CMD ()

	-- ҋ@߂́Aҋ@ԂƋxԂ݂ɓ]
	if (MyState ~= FOLLOW_CMD_ST) then
--		MoveToOwner (homunculus:getId())
		homunculus:moveToOwner()
		MyState = FOLLOW_CMD_ST
		MyDestX, MyDestY = GetV (V_POSITION,GetV(V_OWNER,homunculus:getId()))
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("OnFOLLOW_CMD")
	else
		MyState = IDLE_ST
		MyEnemy = 0 
		MySkill = 0
		TraceAI ("FOLLOW_CMD_ST --> IDLE_ST")
	end

end


function	ProcessCommand (msg)

	if		(msg[1] == MOVE_CMD) then
		OnMOVE_CMD (msg[2],msg[3])
		TraceAI ("MOVE_CMD")
	elseif	(msg[1] == STOP_CMD) then
		OnSTOP_CMD ()
		TraceAI ("STOP_CMD")
	elseif	(msg[1] == ATTACK_OBJECT_CMD) then
		OnATTACK_OBJECT_CMD (msg[2])
		TraceAI ("ATTACK_OBJECT_CMD")
	elseif	(msg[1] == ATTACK_AREA_CMD) then
		OnATTACK_AREA_CMD (msg[2],msg[3])
		TraceAI ("ATTACK_AREA_CMD")
	elseif	(msg[1] == PATROL_CMD) then
		OnPATROL_CMD (msg[2],msg[3])
		TraceAI ("PATROL_CMD")
	elseif	(msg[1] == HOLD_CMD) then
		OnHOLD_CMD ()
		TraceAI ("HOLD_CMD")
	elseif	(msg[1] == SKILL_OBJECT_CMD) then
		OnSKILL_OBJECT_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_OBJECT_CMD")
	elseif	(msg[1] == SKILL_AREA_CMD) then
		OnSKILL_AREA_CMD (msg[2],msg[3],msg[4],msg[5])
		TraceAI ("SKILL_AREA_CMD")
	elseif	(msg[1] == FOLLOW_CMD) then
		OnFOLLOW_CMD ()
		TraceAI ("FOLLOW_CMD")
	end
end


-------------- state process  --------------------
function	OnIDLE_ST ()
	
	TraceAI ("OnIDLE_ST")

	local cmd = List.popleft(ResCmdList)
	if (cmd ~= nil) then		
		ProcessCommand (cmd)	-- \R}h 
		return 
	end

	local	object = homunculus:GetOwnerEnemy()
	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : MYOWNER_ATTACKED_IN")
		return 
	end

	object = homunculus:GetMyEnemy()
	if (object ~= 0) then							-- ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("IDLE_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local distance = GetDistanceFromOwner(homunculus:getId())
	if ( distance > 3 or distance == -1) then		-- MYOWNER_OUTSIGNT_IN
		MyState = FOLLOW_ST
		TraceAI ("IDLE_ST -> FOLLOW_ST")
		return;
	end

end


function	OnFOLLOW_ST ()

	TraceAI ("OnFOLLOW_ST")
	local motion = homunculus:getMotion()

	if (GetDistanceFromOwner(homunculus:getId()) <= 3) then		--  DESTINATION_ARRIVED_IN 
		MyState = IDLE_ST
		TraceAI ("FOLLOW_ST -> IDLW_ST")
		return;

--	elseif (homunculus:getMotion() == MOTION_STAND) then
--		MoveToOwner (homunculus:getId())

	elseif (motion == MOTION_STAND
			or motion == MOTION_MOVE) then 

		homunculus:moveToOwner()

		TraceAI ("FOLLOW_ST -> FOLLOW_ST")
		return;
	end

 	return; 
end


function	OnCHASE_ST ()

	TraceAI ("OnCHASE_ST")

	if (true == IsOutOfSight(homunculus:getId(),MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		MyEnemy = 0
		MyDestX, MyDestY = 0,0
		TraceAI ("CHASE_ST -> IDLE_ST : ENEMY_OUTSIGHT_IN")
		return
	end
	if (true == IsInAttackSight(homunculus:getId(),MyEnemy)) then  -- ENEMY_INATTACKSIGHT_IN
		MyState = ATTACK_ST
		TraceAI ("CHASE_ST -> ATTACK_ST : ENEMY_INATTACKSIGHT_IN")
		return
	end

	local x, y = GetV (V_POSITION,MyEnemy)
	if (MyDestX ~= x or MyDestY ~= y) then			-- DESTCHANGED_IN
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);
		Move (homunculus:getId(),MyDestX,MyDestY)
		TraceAI ("CHASE_ST -> CHASE_ST : DESTCHANGED_IN")
		return
	end

end


function	OnATTACK_ST ()

	TraceAI ("OnATTACK_ST")
	
	if (true == IsOutOfSight(homunculus:getId(),MyEnemy)) then	-- ENEMY_OUTSIGHT_IN
		MyState = IDLE_ST
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return 
	end

	if (MOTION_DEAD == GetV(V_MOTION,MyEnemy)) then   -- ENEMY_DEAD_IN
		MyState = IDLE_ST
		TraceAI ("ATTACK_ST -> IDLE_ST")
		return
	end
		
	if (false == IsInAttackSight(homunculus:getId(),MyEnemy)) then  -- ENEMY_OUTATTACKSIGHT_IN
		MyState = CHASE_ST
		MyDestX, MyDestY = GetV (V_POSITION,MyEnemy);
		Move (homunculus:getId(),MyDestX,MyDestY)
		TraceAI ("ATTACK_ST -> CHASE_ST  : ENEMY_OUTATTACKSIGHT_IN")
		return
	end
	
	if (MySkill == 0) then
		Attack (homunculus:getId(),MyEnemy)
	else
		SkillObject (homunculus:getId(),MySkillLevel,MySkill,MyEnemy)
		MySkill = 0
	end
	TraceAI ("ATTACK_ST -> ATTACK_ST  : ENERGY_RECHARGED_IN")
	return


end


function	OnMOVE_CMD_ST ()

	TraceAI ("OnMOVE_CMD_ST")

	local x, y = GetV (V_POSITION,homunculus:getId())
	if (x == MyDestX and y == MyDestY) then				-- DESTINATION_ARRIVED_IN
		MyState = IDLE_ST
	end
end


function OnSTOP_CMD_ST ()


end


function OnATTACK_OBJECT_CMD_ST ()

	

end


function OnATTACK_AREA_CMD_ST ()

	TraceAI ("OnATTACK_AREA_CMD_ST")

	local	object = homunculus:GetOwnerEnemy()
	if (object == 0) then							
		object = homunculus:GetMyEnemy() 
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		return
	end

	local x , y = GetV (V_POSITION,homunculus:getId())
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
			MyState = IDLE_ST
	end

end


function OnPATROL_CMD_ST ()

	TraceAI ("OnPATROL_CMD_ST")

	local	object = homunculus:GetOwnerEnemy()
	if (object == 0) then
		object = homunculus:GetMyEnemy()
	end

	if (object ~= 0) then							-- MYOWNER_ATTACKED_IN or ATTACKED_IN
		MyState = CHASE_ST
		MyEnemy = object
		TraceAI ("PATROL_CMD_ST -> CHASE_ST : ATTACKED_IN")
		return
	end

	local x , y = GetV (V_POSITION,homunculus:getId())
	if (x == MyDestX and y == MyDestY) then			-- DESTARRIVED_IN
		MyDestX = MyPatrolX
		MyDestY = MyPatrolY
		MyPatrolX = x
		MyPatrolY = y
		Move (homunculus:getId(),MyDestX,MyDestY)
	end

end


function OnHOLD_CMD_ST ()

	TraceAI ("OnHOLD_CMD_ST")
	
	if (MyEnemy ~= 0) then
		local d = GetDistance(MyEnemy,homunculus:getId())
		if (d ~= -1 and d <= GetV(V_ATTACKRANGE,homunculus:getId())) then
				Attack (homunculus:getId(),MyEnemy)
		else
			MyEnemy = 0;
		end
		return
	end


	local object = homunculus:GetOwnerEnemy()
	if (object == 0) then							
		object = homunculus:GetMyEnemy()
		if (object == 0) then						
			return
		end
	end

	MyEnemy = object

end


function OnSKILL_OBJECT_CMD_ST ()
	
end


function OnSKILL_AREA_CMD_ST ()

	TraceAI ("OnSKILL_AREA_CMD_ST")

	local x , y = GetV (V_POSITION,homunculus:getId())
	if (GetDistance(x,y,MyDestX,MyDestY) <= GetV(V_SKILLATTACKRANGE,homunculus:getId(),MySkill)) then	-- DESTARRIVED_IN
		SkillGround (homunculus:getId(),MySkillLevel,MySkill,MyDestX,MyDestY)
		MyState = IDLE_ST
		MySkill = 0
	end

end


function OnFOLLOW_CMD_ST ()

	TraceAI ("OnFOLLOW_CMD_ST")

	local ownerX, ownerY, myX, myY
	ownerX, ownerY = GetV (V_POSITION,GetV(V_OWNER,homunculus:getId())) -- 
	myX, myY = GetV (V_POSITION,homunculus:getId())					  --  
	
	local d = GetDistance (ownerX,ownerY,myX,myY)

	if ( d <= 3) then									-- 3Zȉ̋Ȃ
		return 
	end

	local motion = homunculus:getMotion()
	if (motion == MOTION_MOVE) then					-- ړ
		d = GetDistance (ownerX, ownerY, MyDestX, MyDestY)
		if ( d > 3) then									-- 4Zȏ̋Ȃ
--			MoveToOwner (homunculus:getId())
			homunculus:moveToOwner()
			MyDestX = ownerX
			MyDestY = ownerY
			return
		end
	else									-- ̓ 
--		MoveToOwner (homunculus:getId())
		homunculus:moveToOwner()
		MyDestX = ownerX
		MyDestY = ownerY
		return
	end
	
end
