--------------------------------------------
-- Character NX
--------------------------------------------
Character = {}


-- IuWFNg
function Character.new(charId)
	TraceAI(string.format("Character.new (charId:%d)",charId))

    local metaTable = { __index = Character }
	local _x, _y = GetV (V_POSITION,charId) -- ʒui[

    self = {
    	name = "Character",
    	id = charId,
    	x = _x,
    	y = _y,
		hp = GetV(V_HP, charId),
		sp = GetV(V_SP, charId),
		maxHp = GetV(V_MAXHP, charId),
		maxSp = GetV(V_MAXSP, charId),
		motion = GetV(V_MOTION, charId),
		lastMoveTime = os.time()
	}

    return setmetatable(self, metaTable)
end


-- Setter, Getter
function Character:getName()
	return self.name
end

function Character.setName(value)
	self.name = value
end

function Character:getId()
	return self.id
end

function Character:setId(value)
	self.id = value
end

function Character:getX()
	return self.x
end

function Character.setX(value)
	self.x = value
end

function Character:getY()
	return self.y
end

function Character:setY(value)
	self.y = value
end

function Character:getHp()
	return self.hp
end

function Character:setHp(value)
	self.hp = value
end

function Character:getSp()
	return self.sp
end

function Character:setSp(value)
	self.sp = value
end

function Character:getMaxHp()
	return self.maxHp
end

function Character:setMaxHp(value)
	self.maxHp = value
end

function Character:getMaxSp()
	return self.maxSp
end

function Character:setMaxSp(value)
	self.maxSp = value
end

function Character:getMotion()
	return self.motion
end

function Character:setMotion(value)
	self.motion = value
end

function Character:getLastMoveTime()
	return self.lastMoveTime
end

function Character:setLastMoveTime(value)
	self.lastMoveTime = value
end


-- ֐`
function Character:toString()
    return string.format("(%s) HP:%d/%d SP:%d/%d Id:%d, x:%d, y:%d",
    		self.name,
    		self.hp,
    		self.maxHp,
    		self.sp,
    		self.maxSp,
    		self.id,
    		self.x,
    		self.y)
end


function Character:getSysValue(valType)
	return GetV(valType, self.id)
end


function Character:getDistance(x, y)
	return math.floor(math.sqrt((x-self.x)^2+(y-self.y)^2))
end


function Character:getDistance(id)
	local x, y = GetV(V_POSITION,id)
	if (x==-1 or self.x==-1) then
		return -1
	end
	return self:getDistance(x,y)
end
