--------------------------------------------
-- Homunculus NX
--------------------------------------------
require "./AI/Character.lua"
require "./AI/Const.lua"

-- zʒ萔
HomunType = {
	LIF				= 1,
	AMISTR			= 2,
	FILIR			= 3,
	VANILMIRTH		= 4,
	LIF2			= 5,
	AMISTR2			= 6,
	FILIR2			= 7,
	VANILMIRTH2		= 8,
	LIF_H			= 9,
	AMISTR_H		= 10,
	FILIR_H			= 11,
	VANILMIRTH_H	= 12,
	LIF_H2			= 13,
	AMISTR_H2		= 14,
	FILIR_H2		= 15,
	VANILMIRTH_H2	= 16
}

-- zʖ
HomunTypeName = {}
HomunTypeName[HomunType.LIF] = "LIF"
HomunTypeName[HomunType.LIF2] = "LIF2"
HomunTypeName[HomunType.LIF_H] = "LIF_H"
HomunTypeName[HomunType.LIF_H2] = "LIF_H2"
HomunTypeName[HomunType.AMISTR] = "AMISTR"
HomunTypeName[HomunType.AMISTR2] = "AMISTR2"
HomunTypeName[HomunType.AMISTR_H] = "AMISTR_H"
HomunTypeName[HomunType.AMISTR_H2] = "AMISTR_H2"
HomunTypeName[HomunType.VANILMIRTH] = "VANILMIRTH"
HomunTypeName[HomunType.VANILMIRTH2] = "VANILMIRTH2"
HomunTypeName[HomunType.VANILMIRTH_H] = "VANILMIRTH_H"
HomunTypeName[HomunType.VANILMIRTH_H2] = "VANILMIRTH_H2"
HomunTypeName[HomunType.FILIR] = "FILIR"
HomunTypeName[HomunType.FILIR2] = "FILIR2"
HomunTypeName[HomunType.FILIR_H] = "FILIR_H"
HomunTypeName[HomunType.FILIR_H2] = "FILIR_H2"

Homunculus = {}
setmetatable(Homunculus, { __index = Character })


-- IuWFNg
function Homunculus.new(charId)
	TraceAI(string.format("Homunculus.new (charId:%d)",charId))

    local metaTable = { __index = Homunculus }

	local self = Character.new(charId)

	-- zpǉ
	self.homunType = self:getSysValue(V_HOMUNTYPE)
	self.name = HomunTypeName[self.homunType]

    return setmetatable(self, metaTable)
end


-- ǉ Setter, Getter
function Homunculus:getHomunType()
	return self.homunType
end

function Homunculus:setHomunType(value)
	self.homunType = value
end


-- ֐`
function Homunculus:GetOwnerEnemy()
	TraceAI("Homunculus:GetOwnerEnemy")

	local result = 0
	local owner  = GetV (V_OWNER,self.id)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= self.id) then
			target = GetV (V_TARGET,v)
			if (target == owner) then
				if (IsMonster(v) == 1) then
					enemys[index] = v
					index = index+1
				else
					local motion = GetV(V_MOTION,i)
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (self.id,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end
	
	return result
end


function Homunculus:GetMyEnemy()
	TraceAI("Homunculus:GetMyEnemy")

	local result = 0

	local type = self.homunType

	-- \h~ׂ̈ɁAGetMyEnemyA
	result = self:GetMyEnemyA()

--[[
	if ( type == HomunType.LIF
			or type == HomunType.LIF_H
			or type == HomunType.AMISTR
			or type == HomunType.AMISTR_H
			or type == HomunType.LIF2
			or type == HomunType.LIF_H2
			or type == HomunType.AMISTR2
			or type == HomunType.AMISTR_H2
			) then

		result = self:GetMyEnemyA()

	elseif ( type == HomunType.FILIR
			or type == HomunType.FILIR_H
			or type == HomunType.VANILMIRTH
			or type == HomunType.VANILMIRTH_H 
			or type == HomunType.FILIR2
			or type == HomunType.FILIR_H2
			or type == HomunType.VANILMIRTH2
			or type == HomunType.VANILMIRTH_H2
			) then

		result = self:GetMyEnemyB()

	end
]]--

	return result
end


-------------------------------------------
--  U^ GetMyEnemy
-------------------------------------------
function Homunculus:GetMyEnemyA()
	TraceAI("Homunculus:GetMyEnemyA")

	local result = 0
	local owner  = GetV (V_OWNER, self.id)
	local homId = self.id
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= homId) then
			target = GetV (V_TARGET,v)
			if (target == homId) then
				enemys[index] = v
				index = index+1
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (homId,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end


-------------------------------------------
--  U^ GetMyEnemy
-------------------------------------------
function Homunculus:GetMyEnemyB()
	TraceAI("Homunculus:GetMyEnemyB")

	local result = 0
	local owner  = GetV (V_OWNER,self.id)
	local actors = GetActors()
	local enemys = {}
	local index = 1
	local type
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= self.id) then
			if (1 == IsMonster(v))	then
				enemys[index] = v
				index = index+1
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2(self.id,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end


------------------------------
-- wWֈړ
------------------------------
function Homunculus:move(x, y)
	TraceAI("Homunculus:move")
	
	Move(self.id, x, y)
end


------------------------------
-- ^[QbgID̋߂ֈړ
------------------------------
function Homunculus:moveToTarget(id)
	TraceAI("Homunculus:moveTarget")

	local x, y = GetV(V_POSITION,id)
	local diffX = math.abs(x - self.x)
	local diffY = math.abs(y - self.y)
	local distX
	local distY
	
	-- ړKvȂȂ牽Ȃ
	if( (diffX<=1) and (diffY<=1) ) then
		return
	end

	if( diffX>1 ) then
		if( x>self.x ) then
			distX = x - 1
		elseif( x<self.x ) then
			distX = x + 1
		end
	else
		distX = self.x
	end

	if( diffY>1 ) then
		if( y>self.y ) then
			distY = y - 1
		elseif( y<self.y ) then
			distY = y + 1
		end
	else
		distY = self.y
	end

	self:move(distX, distY)
end


------------------------------
-- I[i[iP~j̋߂ֈړ
------------------------------
function Homunculus:moveToOwner()
	self:moveToTarget(self:getSysValue(V_OWNER))
end
